您的位置:首页 > 其它

codeforces 689D ST表+二分 模板

2017-05-31 00:18 309 查看
Mike and !Mike are old childhood rivals, they are opposite in everything they do, except programming. Today they have a problem they cannot solve on their own, but together (with you) — who knows?

Every one of them has an integer sequences a and b of length n. Being given a query of the form of pair of integers (l, r), Mike can instantly tell the value of while !Mike can instantly tell the value of .

Now suppose a robot (you!) asks them all possible different queries of pairs of integers (l, r) (1 ≤ l ≤ r ≤ n) (so he will make exactly n(n + 1) / 2 queries) and counts how many times their answers coincide, thus for how many pairs is satisfied.

How many occasions will the robot count?

Input

The f
4000
irst line contains only integer n (1 ≤ n ≤ 200 000).

The second line contains n integer numbers a1, a2, …, an ( - 109 ≤ ai ≤ 109) — the sequence a.

The third line contains n integer numbers b1, b2, …, bn ( - 109 ≤ bi ≤ 109) — the sequence b.

Output

Print the only integer number — the number of occasions the robot will count, thus for how many pairs is satisfied.

Example

Input

6

1 2 3 2 1 4

6 7 1 2 3 2

Output

2

Input

3

3 3 3

1 1 1

Output

0

Note

The occasions in the first sample case are:

1.l = 4,r = 4 since max{2} = min{2}.

2.l = 4,r = 5 since max{2, 1} = min{2, 3}.

There are no occasions in the second sample case since Mike will answer 3 to any query pair, but !Mike will always answer 1.

题意:

给定两个等长区间,求相同l,r情况下,有多少个区间,第一个序列的最大值和第二个序列的最小值相同。

因为最大值是一个单调递增的函数,最小值是一个单调递减的函数,所以 i区间到mid区间的 (最大值-最小值) 是一个单调递增的函数。所以枚举左端点,不断的进行二分右端点,分别进行两个二分可以得到两个右端点,第一个右端点,代表的是满足,max(i,mid)==min(i,mid) 的右边界最大值,然后第二个右端点表示的是max(i,mid)==min(i,mid) 的右边界最小值。 两者一减,那么就是左边界为i,右边界在(t1~t2)满足,这些是都满足的区间数。

献上代码很好理解。。

无敌快的代码

#include <bits/stdc++.h>
using namespace std;
int n;
int a[201000],b[201000];
int mn[201000][30];
int mx[201000][30];
int num;
void init()
{
for(int i=1;i<=n;i++)
{
mx[i][0]=a[i],mn[i][0]=b[i];
}
for(int j = 1; (1<<j) <= n; ++j)
for(int i = 1; i + (1<<j) - 1 <= n; ++i)
{
mx[i][j] = max(mx[i][j-1],mx[i+(1<<(j-1))][j-1]);
mn[i][j] = min(mn[i][j-1],mn[i+(1<<(j-1))][j-1]);
}
}

int rmq(int i,int j,int f)
{
int k=0;
while((1 << (k + 1)) <= j - i + 1) k++;
int res=0;
if(f==0)
res=min(mn[i][k],mn[j-(1<<k)+1][k]);
if(f==1)
res=max(mx[i][k],mx[j-(1<<k)+1][k]);
return res;
}

int main()
{
scanf("%d",&n);
for(int i=1;i<=n;i++)
scanf("%d",&a[i]);
for(int i=1;i<=n;i++)
scanf("%d",&b[i]);
init();
long long ans=0;
for(int i=1;i<=n;i++)
{
int l=i,r=n;
int t1=-1,t2=-1;
while(l<=r)
{
int mid=(l+r)>>1;
int re1=rmq(i,mid,1),re2=rmq(i,mid,0);
if(re1>re2)
{
r=mid-1;
}
else if(re1<re2)
{
l=mid+1;
}
else if(re1==re2){
t1=mid;
r=mid-1;
}
}
if(t1==-1) continue;
l=i,r=n;
while(l<=r)
{
int mid=(l+r)>>1;
int re1=rmq(i,mid,1),re2=rmq(i,mid,0);
if(re1>re2)
r=mid-1;
else if(re1<re2)
l=mid+1;
else
{
t2=mid;
l=mid+1;
}
}
ans+=t2-t1+1;
}
printf("%lld\n",ans );
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: